# Defold live update

Apart from the whole application update, a live update is used heavily in mahjong games due to bug fixing and new features. Defold provide an update mechanism based on collection proxy. And a resource can be bundled inside the application or be excluded with live update feature. The resource inside a bundled application can't be updated.

## Per collection proxy live update

According to the system architecture, there will be following
proxies:

1. main collection. The entry of the engine in startup which is configured in the project setting. It will hold an excluded splash collection proxy. If any code or resource which needs the live update, it shall not be referenced in the main collection. Otherwise, it will be bundled in the application.
2. splash collection proxy. The brand display is the first target of this collection. Then there will be the lobby, circle and lots of mahjong game collection proxies which are all excluded. The game model(client, service and storage) are referenced in the splash collection and will be downloaded when the splash is loaded. The splash collection is running without unload and behaviors as a scheduler.
3. lobby collection proxy. All components in the lobby view will be downloaded when the lobby is loaded.
4. circle collection proxy. All components in the circle view will be downloaded when the circle is loaded. 
5. mahjong game proxy. Each mahjong game will have a dedicate proxy in which releated missing resource will be downloaded when the game is loaded.

## Update strategy

When write this page, there are 900 files in the full bundled application and the total size is about 90MB using highest quality resources.
As a rough estimation, there will be about 2000~3000 files in total and the full bundled application size will be about 200+ MB using normal quality resources. The update must have suitable strategy to download files from the server to reduce the side effect of the downloading. A single compressed package is not that good due to too many versions.

1. Static and dynamic resources. The font, 3D models, full screen images and background sound are not changed frequently. This kind of resource has the biggest share of the application size which can be put in the main collection and bundled in the application without live update. Dynamic resource are the source (lua, script and defold engine releated factory and game object etc). These are small file(1~20 KB), but the count is large. Http downloading for large count of files cost too much time.(In the local machine, 200+ files cost about 5 seconds)
2. Package download and single file download. The lobby and circle are two main proxy which are able to do a package download. The mahjong game count might be 200+, it's hard to package for each via the defold editor. The mahjong game will use single file download. In worst case, a new game might have up to 80 files with 10 MB data. The worst downloading time cost is still acceptable(might be inside 30 seconds) in a suitable network environment.
3. multi level update. When the application is start at the first time, it only holds some static resources. The main collection can decide to download the package for the lobby and circle collection proxy. This is the only try for the package downloading. After that, only single file downloading will be triggered by the splash proxy when switch to lobby/circle/game proxy. There might be an optimization for the package downloading when there is a big and individual feature update with large count of files. It depends on the CDN network environment.