# Static view

## Defold resource management

The manifest is an internal data structure that holds a list of all resources included in a build as well as the hash value of each resource. The Live update functionality uses the manifest to track what is part of the built game, list what can be loaded from external sources, and if that happens, make certain that the loaded data is intact.

## Game resource management

The collection proxy component is used to load and unload new game “worlds” dynamically based on the content of a collection file. They can be used to implement switching between game levels, GUI screens, loading and unloading of narrative “scenes” throughout a level, loading/unloading of mini-games and more. There are several worlds:

1. main collection. The entry of the engine in startup which is configured in the project setting.
2. scheduler world. It's an container of all other real game logic worlds.
3. lobby world. All game logics are processed in this world except the 3D desk physical world.
4. game worlds. For each game, a individual world is created. A core collection is used as part of the world to process all common logic in the desk. And a dedicated implementation collection is used to process the special game logic.

## Layered architecture

There are four core layers in the system as following:

gui

service/storage/notification

connection

system facility(extension included)

### gui layer

The gui layer here is a coarsness concept. It's designed according following core concepts:

1. Access the data in the storage.
2. Receive a event(message) from the notification.
3. Response to the user input.
4. Use the service to trigger an action.

Apart from these core concepts, other behaviors provided via the defold engine are also supported. For example, the msg communication between ui components in a same context(go, collection). Additionally, there are two frameworks gooey/monarch from defold community(not engine, these framworks are not offically maintained by defold.)

#### gooey

#### monarch

### service/storage/notification

These concepts are horizontal sub systems for different purposes.

#### service

A service is used when there is a domain logic processing is needed. For example, the account, mahjong and replay. The service receive the protocol message from the conection, then updata the data in storage and post event. A complicated service may also be supported by a manager in implementation.

#### storage

A data centre that provide interface to set/get data including presistent and non-persistent data.

#### notification

A event register/publish module that provide asyn communication with system/logic event based on the defold engine msg.

### connection

There are tcp and web socket connections. A connection maintains the heartbeat. And the lua-json-protobuf message pipe line is also processed.

### system facility

There are several native extentison provided via C/C++/JAVA/OC.

1. openssl
2. protobuf
3. boost asyn socket
4. sqlite3
5. websocket
6. reachability


# Dynamic view(TBD)

Run time behavior description

## Startup sequence
